package org.modeshape.ejbtest;

import javax.annotation.Resource;
import javax.ejb.Asynchronous;
import javax.ejb.Stateless;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.jcr.Node;
import javax.jcr.Session;
import javax.jcr.SimpleCredentials;
import javax.jcr.nodetype.NodeType;
import javax.naming.InitialContext;
import javax.transaction.UserTransaction;

import org.jboss.logging.Logger;

@Stateless
@TransactionManagement(TransactionManagementType.BEAN)
public class CreateNodesTest  {
	
	private static Logger log = Logger.getLogger(CreateNodesTest.class);
	
	private static int COUNT = 10;
	
//  Does not work yet
//	@Resource(lookup="jcr/sample")
//	private Repository repository;
	
	@Resource
	private UserTransaction ut;
	
	@Asynchronous
	public void run() throws Exception {
		ut.begin();
		InitialContext context = new InitialContext();
		javax.jcr.Repository repository = (javax.jcr.Repository) context.lookup("jcr/sample");
		Session session = repository.login(new SimpleCredentials("admin", "admin".toCharArray()));
		Node root = session.getRootNode();
		for (int i = 1; i <= COUNT; i++) {
			Node node = root.addNode("node" + i, NodeType.NT_UNSTRUCTURED);
			node.setProperty("prop", "Property value for " + node.getIdentifier());
			log.info("Populating " + node.getPath());
			for (int j = 1; j <= COUNT; j++) {
				Node child = node.addNode("child" + j, NodeType.NT_UNSTRUCTURED);
				child.setProperty("prop", "Property value for " + child.getIdentifier());
				log.info("Populating " + child.getPath());
				for (int k = 1; k <= COUNT; k++) {
					Node grandChild = child.addNode("grandchild" + k, NodeType.NT_UNSTRUCTURED);
					grandChild.setProperty("prop", "Property value for " + grandChild.getIdentifier());
				}
			}
			log.info("Saving session and committing transaction");
			session.save();
			ut.commit();
			ut.begin();
		}
		session.save();
		session.logout();
		ut.commit();
		
		log.info("CreateNodesTest completed");
	}
}
